'use strict';

module.exports = {

  _setTag() {
    if (this.params.tag) {
      if (this.params.tag === true || this.params.tag === 'true') {
        this.params.jsonFiles.forEach((file) => {
          if (this.fsExists(file)) {
            const config = this.fsReadConfig(file);
            if (config.version) {
              this.logger.info('Actual version on', '#cyan', file, 'is', '#green', config.version);
              this.params.tag = config.version;
            }
          }
        });
      }
      return this.execute(this.gitCmd, ['tag', this.params.tag]);
    } else {
      return Promise.resolve();
    }
  },

  _deleteBranch() {
    if (this.params.deletedBranch) {
      return this.execute(this.gitCmd, ['push', 'origin', `:${this.params.deletedBranch}`])
        .catch((e) => this.logger.info('continue execution!'));
    } else {
      return Promise.resolve();
    }
  },

  _push() {
    return this.execute(this.gitCmd, ['push', '--all'])
      .then(() => this.execute(this.gitCmd, ['push', '--tags']));
  },

  run(ok, ko) {
    return Promise.resolve()
      .then(() => this._setTag())
      .then(() => this._deleteBranch())
      .then(() => this._push())
      .then(ok, ko);
  }
};